%{

/*
 * action.y
 * 
 * A parser for the commands for the `wimupdate' program.
 *
 * wimlib - Library for working with WIM files 
 *
 * Copyright (C) 2012 Eric Biggers
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option) any
 * later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along
 * with this library; if not, write to the Free Software Foundation, Inc., 59
 * Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */

#include "wimupdate.h"

%}

%union {
	char *str;
	struct list *list;
	int command_word;
}

%token	<command_word>	TOK_COMMAND_WORD;
%token	<str>	TOK_ARG 
%token	<str>	TOK_END_OF_COMMAND
%type	<str>	input;
%type	<list>	arg_list;
%type	<list>	command;

%%

input: /* empty */ { }
     | error separator input { print_available_commands(); return 1; }
     | command {
	}
     | command separator input {
	     } 
	;

separator: TOK_END_OF_COMMAND | TOK_END_OF_COMMAND separator { }
	;

command: TOK_COMMAND_WORD arg_list {
		$$ = $2;
		$$->command_word = $1;
		if (!execute_command($$)) return 1;
		} 
	;

arg_list: /* empty */ {
		$$ = new_list();
	}
	;

arg_list: TOK_ARG arg_list {
		$$ = $2;
		list_prepend_string($$, xstrdup($1));
		} 
	;


%%

