#ifndef _WIMUPDATE_H
#define _WIMUPDATE_H

#include "wimlib.h"

extern WIMStruct *w;

enum command_word {
#define DEFCMD(u, l, s) u ,
#include "commands.def"
#undef DEFCMD
};

struct list_node {
	char *str;
	struct list_node *next;
};

struct list {
	struct list_node *first;
	struct list_node *last;
	enum command_word command_word;
};


void list_add_string(struct list *list, char *str);
void list_prepend_string(struct list *list, char *str);
void list_add_string_from_file(struct list *list, const char *filename);
struct list *new_list();
void *xmalloc(size_t len);
char *xstrdup(const char *s);
bool execute_command(struct list *command);
int yyparse(void);
int yylex(void);
int yyerror(const char *err);
bool execute_action_string(const char *s);
void print_available_commands();

#endif
